local hostUrl = "http://localhost:8080";
local hostUrlLength = string.len(hostUrl)
local petTypes = {"bird", "cat", "dog", "hamster", "lizard", "snake"}

local newOwnerRequest = 'firstName=First%d&lastName=Last%d&address=Address%d&city=City%d&telephone=%d'
local newPetRequest = 'name=Pet%d&birthDate=2010-10-05&type=%s'
local newVisitRequest = 'date=2021-02-23&description=Broken+leg'

local postHeaders = {}
postHeaders["content-type"] = "application/x-www-form-urlencoded"

local ownerCounter
init = function(args)
   tid = math.random(1, 1000000)
   ownerCounter = 100000000 + tid
   petCounter = 100000000 + tid
end


local ownerPath
local petId
local state = 0
request = function()
    if state == 0 then
        -- navigate to http://localhost:8080/owners/find
        method = "GET"
        path = "/owners/find"
        headers = nil
        body = ""
    elseif state == 1 then
        -- navigate to http://localhost:8080/owners/new
        path = "/owners/new"
    elseif state == 2 then
        -- create a new owner at http://localhost:8080/owners/new
        ownerCounter = ownerCounter + 1
        method = "POST"
        headers = postHeaders
        body = string.format(newOwnerRequest, ownerCounter, ownerCounter, ownerCounter, ownerCounter, ownerCounter)
    elseif state == 3 then
        -- navigate to http://localhost:8080/owners/%d
        method = "GET"
        path = ownerPath
        headers = nil
        body = ""
    elseif state == 4 then
        -- navigate to http://localhost:8080/owners/%d/pets/new
        path = ownerPath .. "/pets/new"
    elseif state == 5 then
        -- create a new pet for the current owner at http://localhost:8080/owners/%d/pets/new
        petCounter = petCounter + 1
        method = "POST"
        path = ownerPath .. "/pets/new"
        headers = postHeaders
        body = string.format(newPetRequest, petCounter, petTypes[(petCounter % #petTypes) + 1])
    elseif state == 6 then
        -- navigate to http://localhost:8080/owners/%d
        method = "GET"
        path = ownerPath
        headers = nil
        body = ""
    elseif state == 7 then
        -- navigate to http://localhost:8080/owners/%d/pets/%d/visits/new
        path = ownerPath .. "/pets/" .. petId .. "/visits/new"
    elseif state == 8 then
        -- create a new visit for the current pet at http://localhost:8080/owners/%d/pets/%d/visits/new
        method = "POST"
        headers = postHeaders
        body = string.format(newVisitRequest)
    elseif state == 9 then
        -- navigate to http://localhost:8080/owners/%d
        method = "GET"
        path = ownerPath
        headers = nil
        body = ""
    end
    
    state = (state + 1) % 10

    local req = wrk.format(method, path, headers, body)
    print(" " .. req)
    return req
end


response = function(status, headers, body)
    print("STATUS= " .. status)
    print("BODY= " .. body)
    if state == 3 then
        ownerPath = string.sub(headers["Location"], hostUrlLength + 1, -1)
    elseif state == 7 then
        petId = string.match(body, 'pets/(%d+)/visits/new')
    end
end

